<?php

namespace LQDN\Tests\Functional\Handler;

use LQDN\Command\DonationInvalidateCommand;
use LQDN\Command\DonationResetPdfCommand;
use LQDN\Command\DonationValidateCommand;
use LQDN\Tests\Functional\FunctionalTest;

class DonationHandlerTest extends FunctionalTest
{
    public function testDonationValidation()
    {
        $this->assertEquals(1, $this->getDonation(1)['status']);
        $this->container['command_handler']->handle(new DonationInvalidateCommand(1));
        $this->assertEquals(0, $this->getDonation(1)['status']);
        $this->container['command_handler']->handle(new DonationValidateCommand(1));
        $this->assertEquals(1, $this->getDonation(1)['status']);
    }

    public function testDonationResetPdf()
    {
        $this->assertEquals('pdf', $this->getDonation(1)['pdf']);
        $this->container['command_handler']->handle(new DonationResetPdfCommand(1));
        $this->assertEquals('', $this->getDonation(1)['pdf']);
    }

    /**
     * Retrieve a donation
     *
     * @return []
     */
    private function getDonation($id)
    {
        return $this->container['db']->fetchAssoc("SELECT * FROM dons WHERE id = $id");
    }
}
